-- Dr. Azzy's Mercenary AI
-- Written by Dr. Azzy of iRO Loki
-- Permission granted to distribute in unmodified form
-- Please contact me via the iRO Forums if you wish to modify
-- so that we can work together to extend and improve this AI.
-- Version 1.06 (features added, see release notes)

require "./AI/USER_AI/Const_.lua"
require "./AI/USER_AI/Util_.lua"
require "./AI/USER_AI/AzzyUtil.lua"
require "./AI/USER_AI/A_Config.lua"
require "./AI/USER_AI/A_Friends.lua"
require "./AI/USER_AI/Tactics.lua"
require "./AI/USER_AI/Mob_ID.lua"
require "./AI/USER_AI/A_Tactics.lua"

-----------------------------
-- state
-----------------------------
IDLE_ST					= 0
FOLLOW_ST				= 1
CHASE_ST				= 2
ATTACK_ST				= 3
MOVE_CMD_ST				= 4
STOP_CMD_ST				= 5
ATTACK_OBJECT_CMD_ST			= 6
ATTACK_AREA_CMD_ST			= 7
PATROL_CMD_ST				= 8
HOLD_CMD_ST				= 9
SKILL_OBJECT_CMD_ST			= 10
SKILL_AREA_CMD_ST			= 11
FOLLOW_CMD_ST				= 12
RANDWALK_ST				= 100
ORBITWALK_ST				= 101
REST_ST					= 102
----------------------------



------------------------------------------
-- global variable
------------------------------------------
MyState				= IDLE_ST	--  ´ ޽
MyEnemy				= 0		--  id
MyDestX				= 0		--  x
MyDestY				= 0		--  y
MyPatrolX			= 0		--   x
MyPatrolY			= 0		--   y
ResCmdList			= List.new()	--  ɾ Ʈ 
MyID				= 0		-- 뺴 id
MySkill				= 0		-- 뺴 ų
MySkillLevel			= 0		-- 뺴 ų 
RandomMoveTries			= 0
--Autoskill timeout counters
QuickenTimeout			= 0
GuardTimeout			= 0
MagTimeout			= 0
SightTimeout			= 0
SkillTimeout			= 0
ProvokeOwnerTimeout		= 0
SacrificeTimeout		= 0
AutoSkillTimeout		= 0
--Advanced movement commands
OrbitWalkStep			= 0
OrbitWalkTries			= 0
KiteDestX			= 0
KiteDestY			= 0
--Other stuff
MyStart				= GetTick()
MySkillUsedCount		= 0
ChaseGiveUpCount		= 0
------------------------------------------

-----------Config checking----------------

if (UseRandomWalk==1 and UseOrbitWalk==1) then
	UseOrbitWalk=0
end

if (UseAutoSkill==0 and UseSkillOnly==1) then
	UseSkillOnly = 0
end

if (AutoSkillLimit <= 0) then
	AutoSkillLimit = 10000
end
--####################################
--######## Command Processing ########
--####################################

function	OnMOVE_CMD (x,y)
	
	TraceAI ("OnMOVE_CMD")

	if ( x == MyDestX and y == MyDestY and MOTION_MOVE == GetV(V_MOTION,MyID)) then
		return		--  ̵   ̸ ó ʴ´. 
	end

	local curX, curY = GetV (V_POSITION,MyID)
	if (math.abs(x-curX)+math.abs(y-curY) > 15) then		--   Ÿ ̸̻ ( հŸ ó ʱ )
		List.pushleft (ResCmdList,{MOVE_CMD,x,y})			--   ̵ Ѵ. 	
		x = math.floor((x+curX)/2)							-- ߰  ̵Ѵ.  
		y = math.floor((y+curY)/2)							-- 
	end

	Move (MyID,x,y)	
	
	MyState = MOVE_CMD_ST
	MyDestX = x
	MyDestY = y
	MyEnemy = 0
	MySkill = 0

end


function	OnSTOP_CMD ()

	TraceAI ("OnSTOP_CMD")

	if (GetV(V_MOTION,MyID) ~= MOTION_STAND) then
		Move (MyID,GetV(V_POSITION,MyID))
	end
	MyState = IDLE_ST
	MyDestX = 0
	MyDestY = 0
	MyEnemy = 0
	MySkill = 0

end


function	OnATTACK_OBJECT_CMD (id)

	TraceAI ("OnATTACK_OBJECT_CMD")

	MySkill = 0
	MyEnemy = id
	MyState = CHASE_ST

end


function	OnATTACK_AREA_CMD (x,y)

	TraceAI ("OnATTACK_AREA_CMD")

	if (x ~= MyDestX or y ~= MyDestY or MOTION_MOVE ~= GetV(V_MOTION,MyID)) then
		Move (MyID,x,y)	
	end
	MyDestX = x
	MyDestY = y
	MyEnemy = 0
	MyState = ATTACK_AREA_CMD_ST
	
end

function	OnPATROL_CMD (x,y)

	TraceAI ("OnPATROL_CMD")

	MyPatrolX , MyPatrolY = GetV (V_POSITION,MyID)
	MyDestX = x
	MyDestY = y
	Move (MyID,x,y)
	MyState = PATROL_CMD_ST

end


function	OnHOLD_CMD ()

	TraceAI ("OnHOLD_CMD")

	MyDestX = 0
	MyDestY = 0
	MyEnemy = 0
	MyState = HOLD_CMD_ST

end


function	OnSKILL_OBJECT_CMD (level,skill,id)

	TraceAI ("OnSKILL_OBJECT_CMD")
	TraceAI (skill)
	MySkillLevel = level
	MySkill = skill
	MyEnemy = id
	MyState = CHASE_ST

end


function	OnSKILL_AREA_CMD (level,skill,x,y)

	TraceAI ("OnSKILL_AREA_CMD")

	Move (MyID,x,y)
	MyDestX = x
	MyDestY = y
	MySkillLevel = level
	MySkill = skill
	MyState = SKILL_AREA_CMD_ST
	
end

function	OnFOLLOW_CMD ()

	--  ¿ ޽Ļ¸  ȯŲ. 
	if (MyState ~= FOLLOW_CMD_ST) then
		BetterMoveToOwner (MyID)
		MyState = FOLLOW_CMD_ST
		MyEnemy = 0 
		MySkill = 0
		TraceAI ("OnFOLLOW_CMD")
	else
		MyState = IDLE_ST
		MyEnemy = 0 
		MySkill = 0
		TraceAI ("FOLLOW_CMD_ST --> IDLE_ST")
	end

end




function	ProcessCommand (msg)

	if		(msg[1] == MOVE_CMD) then
		OnMOVE_CMD (msg[2],msg[3])
		TraceAI ("MOVE_CMD")
	elseif	(msg[1] == STOP_CMD) then
		OnSTOP_CMD ()
		TraceAI ("STOP_CMD")
	elseif	(msg[1] == ATTACK_OBJECT_CMD) then
		OnATTACK_OBJECT_CMD (msg[2])
		TraceAI ("ATTACK_OBJECT_CMD")
	elseif	(msg[1] == ATTACK_AREA_CMD) then
		OnATTACK_AREA_CMD (msg[2],msg[3])
		TraceAI ("ATTACK_AREA_CMD")
	elseif	(msg[1] == PATROL_CMD) then
		OnPATROL_CMD (msg[2],msg[3])
		TraceAI ("PATROL_CMD")
	elseif	(msg[1] == HOLD_CMD) then
		OnHOLD_CMD ()
		TraceAI ("HOLD_CMD")
	elseif	(msg[1] == SKILL_OBJECT_CMD) then
		OnSKILL_OBJECT_CMD (msg[2],msg[3],msg[4],msg[5])
		TraceAI ("SKILL_OBJECT_CMD")
	elseif	(msg[1] == SKILL_AREA_CMD) then
		OnSKILL_AREA_CMD (msg[2],msg[3],msg[4],msg[5])
		TraceAI ("SKILL_AREA_CMD")
	elseif	(msg[1] == FOLLOW_CMD) then
		OnFOLLOW_CMD ()
		TraceAI ("FOLLOW_CMD")
	end
end



--###############################
--######## State Process ########
--###############################

function	OnIDLE_ST ()
	
	TraceAI ("OnIDLE_ST")

	if (DoIdleTasks()==nil) then
		return
	end
	
	local	object = GetOwnerEnemy (MyID)
	if (object ~= 0) then							-- MYOWNER_ATTACKED_IN
		MyState = CHASE_ST
		MyEnemy = object
		TraceAI ("IDLE_ST -> CHASE_ST : MYOWNER_ATTACKED_IN")
		return 
	end
	object = GetMyEnemy (MyID)
	if (object ~= 0) then							-- ATTACKED_IN
		MyState = CHASE_ST
		MyEnemy = object
		TraceAI ("IDLE_ST -> CHASE_ST : ATTACKED_IN")
		return
	end

	local distance = GetDistanceFromOwner(MyID)
	if (UseRandWalk==1 or UseOrbitWalk==1) then
		if ( distance > MoveBounds or distance == -1) then		-- MYOWNER_OUTSIGNT_IN
			MyState = FOLLOW_ST
			TraceAI ("IDLE_ST -> FOLLOW_ST")
			return
		end
	elseif ( distance > DiagonalDist(FollowStayBack+1) or distance == -1) then		-- MYOWNER_OUTSIGNT_IN
		MyState = FOLLOW_ST
		OnFOLLOW_ST()
		TraceAI ("IDLE_ST -> FOLLOW_ST")
		return
	end
	local owner=GetV(V_OWNER,MyID)
	local ownermotion=GetV(V_MOTION,owner)
	if (distance < 2 and ownermotion == MOTION_STAND and UseRandWalk==1 and HPPercent(MyID) > AggroHP) then
		DoRandomMove()
		return
	end
	if (ownermotion==0 and GetV(V_MOTION,MyID)==0 and UseOrbitWalk > 0) then
		MyState=ORBITWALK_ST
		OrbitWalkStep=0
		return
	end

end

function	OnFOLLOW_ST ()

	TraceAI ("OnFOLLOW_ST")

	if (GetDistanceFromOwner(MyID) <= DiagonalDist(FollowStayBack+1)) then		--  DESTINATION_ARRIVED_IN 
		MyState = IDLE_ST
		TraceAI ("FOLLOW_ST -> IDLE_ST")
		return;
	else
		BetterMoveToOwner (MyID,FollowStayBack)
		TraceAI ("FOLLOW_ST -> FOLLOW_ST")
		return;
	end

end




function	OnCHASE_ST ()

	TraceAI ("OnCHASE_ST")

	if (true == IsOutOfSight(MyID,MyEnemy)) then	-- ENEMY_OUTSIGHT_IN
		MyState = IDLE_ST
		MyEnemy = 0
		MyDestX, MyDestY = 0,0
		TraceAI ("CHASE_ST -> IDLE_ST : ENEMY_OUTSIGHT_IN")
		return
	end
	if (true == IsInAttackSight(MyID,MyEnemy)) then  -- ENEMY_INATTACKSIGHT_IN
		if(IsNotKS(MyID,MyEnemy)==1) then
			MyState = ATTACK_ST
			OnATTACK_ST()
			TraceAI ("CHASE_ST -> ATTACK_ST : ENEMY_INATTACKSIGHT_IN")
		else
			MyState = IDLE_ST
			MyEnemy = 0
			MyDestX, MyDestY = 0,0
			TraceAI ("CHASE_ST -> IDLE_ST : Enemy is taken")
		end
		return
	end

	local x, y = GetV (V_POSITION,MyEnemy)
	if (MyDestX ~= x or MyDestY ~= y) then			-- DESTCHANGED_IN
		MyDestX, MyDestY = GetV (V_POSITION,MyEnemy)
	end
	Move (MyID,MyDestX,MyDestY)
	TraceAI ("CHASE_ST -> CHASE_ST : DESTCHANGED_IN"..MyDestX.." "..MyDestY)
	return
end




function	OnATTACK_ST ()

	TraceAI ("OnATTACK_ST")		
	
	if (true == IsOutOfSight(MyID,MyEnemy)) then	-- ENEMY_OUTSIGHT_IN
		MyState = IDLE_ST
		MyEnemy = 0
		MySkillUseCount= 0
		TraceAI ("ATTACK_ST -> IDLE_ST")
		return 
	end

	if (MOTION_DEAD == GetV(V_MOTION,MyEnemy)) then   -- ENEMY_DEAD_IN
		MyState = IDLE_ST
		MyEnemy = 0
		MySkillUseCount= 0
		TraceAI ("ATTACK_ST -> IDLE_ST")
		return
	end
		
	if (false == IsInAttackSight(MyID,MyEnemy)) then  -- ENEMY_OUTATTACKSIGHT_IN
		MyState = CHASE_ST
		MyDestX, MyDestY = GetV (V_POSITION,MyEnemy);
		Move (MyID,MyDestX,MyDestY)
		TraceAI ("ATTACK_ST -> CHASE_ST  : ENEMY_OUTATTACKSIGHT_IN")
		return
	end
	if (UseAutoPushback > 0) then
		if DoAutoPushback(MyID)  == nil then
			return
		end
	end
	local areatarget=-1
	local areatargetx=-1
	local areatargety=-1
	local usemobskill=0
	local TargetMode
	if (MySkill==0 and UseAutoSkill == 1 and GetTick() >= AutoSkillTimeout and MySkillUsedCount < AutoSkillLimit) then
		TraceAI ("Starting autoskill routine")
		local mobcount=GetMobCount(MyID,1,GetV(V_OWNER,MyID))
		if (mobcount >= AutoMobCount and AutoMobCount ~=0) then
			TraceAI("Attempting to use Anti Mob Skill")
			local skill,level,sp,targetmode = GetMobSkill(GetV(V_MERTYPE,MyID))
			if (skill > 0 and GetV(V_SP,MyID) >= sp+UseAutoSkill_MinSP) then
				TraceAI("Yes, mercenary has Antimob skill and sp to use it")
				usemobskill=1
				TargetMode=targetmode
				MySkill=skill
				MySkillLevel=level
				if (targetmode==0) then
					areatarget=MyID
					TraceAI("Selftargeted Antimob Skill")
				elseif (targetmode==1) then
					TraceAI("Targeted Antimob Skill")
					if (skill == ML_BRANDISH) then
						areatarget=GetBestBrandishTarget(MyID)
					else
						areatarget=MyEnemy
					end
				else -- Area target instead of monster target
					areatargetx,areatargety=GetV(V_POSITION,MyEnemy)
					TraceAI("Area Targeted Antimob Skill")
				end
			end
		end
		if (MySkill==0) then
			TraceAI("Trying single target skill")
			local skill,level,sp = GetAtkSkill(GetV(V_MERTYPE,MyID))
			if (skill > 0 and GetV(V_SP,MyID) >= sp+UseAutoSkill_MinSP) then
				TraceAI("Yes, mercenary has single target skill and sp to use it")
				MySkill=skill
				MySkillLevel=level
				AutoSkillTimeout=GetTick() + AutoSkillDelay
			else
				TraceAI("AutoSkill failed - no skills or no SP")
			end
		end
	end
	if (usemobskill==1) then
		if (TargetMode ==2) then
			SkillGround(MyID,MySkillLevel,MySkill,areatargetx,areatargety)
		else
			SkillObject(MyID,MySkillLevel,MySkill,areatarget)
		end
		MySkillUsedCount=MySkillUsedCount+1
		usemobskill=0
		MySkill=0
	elseif (MySkill == 0) then
		if (UseSkillOnly == 0) then
			Attack (MyID,MyEnemy)
		end
	else
		if (1 == SkillObject(MyID,MySkillLevel,MySkill,MyEnemy)) then
			MyEnemy = 0
		end
		MySkillUsedCount=MySkillUsedCount+1
		MySkill = 0
	end
	TraceAI ("ATTACK_ST -> ATTACK_ST")
	return


end

function	OnREST_ST ()
	TraceAI("OnREST_ST")
	if (DoIdleTasks()==nil) then
		return
	end
	local	object = GetOwnerEnemy (MyID)
	if (object ~= 0) then		--Check for monsters attacking owner
		MyState = CHASE_ST
		MyEnemy = object
		TraceAI ("REST_ST -> CHASE_ST : MYOWNER_ATTACKED_IN")
		return 
	end
	object = GetMyEnemy (MyID) 	--Note that GetMyEnemy() is smart enough to use non-aggro
	if (object ~= 0) then		--targeting function when the mercenary is in REST_ST
		MyState = CHASE_ST
		MyEnemy = object
		TraceAI ("IDLE_ST -> CHASE_ST : ATTACKED_IN")
		return
	end
	
	--If theres nothing else to do, return to the "rest station"
	
	x,y=GetV(V_POSITION,MyID)
	ox,oy=GetV(V_POSITION,GetV(V_OWNER,MyID))
	xoff=ox-x
	yoff=oy-y
	TraceAI(xoff.." "..ox.." "..x)
	if (xoff~=RestXOff or yoff~=RestYOff) then
		MyDestX=ox+RestXOff
		MyDestY=oy+RestYOff
		Move(MyID,MyDestX,MyDestY)
	else
		MyDestX,MyDestY=0,0
	end
	if (GetV(V_MOTION,GetV(V_OWNER,MyID))~=MOTION_SIT) then
		MyState=IDLE_ST
		TraceAI("REST_ST -> IDLE_ST: Owner stood up")
	end
end

function	OnRANDWALK_ST ()

	TraceAI ("OnRANDWALK_ST")
	RandWalkTries = RandWalkTries + 1
	local x, y = GetV (V_POSITION,MyID)
	local mymotion = GetV(V_MOTION,MyID)
	if (x == MyDestX and y == MyDestY) then				-- DESTINATION_ARRIVED_IN
		MyState = IDLE_ST
	elseif (RandWalkTries > 2 and mymotion==MOTION_STAND) then
		MyDestX=0
		MyDestY=0
		MyState= IDLE_ST
	end
end

function	OnORBITWALK_ST()
	TraceAI ("OnORBITWALK_ST")
	if (DoIdleTasks()==nil) then
		return
	end
	local	object = GetOwnerEnemy (MyID)
	if (object ~= 0) then							-- MYOWNER_ATTACKED_IN
		MyState = CHASE_ST
		MyEnemy = object
		TraceAI ("ORBITWALK_ST -> CHASE_ST : ALLY_ATTACKED_IN")
		return 
	end

	object = GetMyEnemy (MyID)
	if (object ~= 0) then							-- ATTACKED_IN
		MyState = CHASE_ST
		MyEnemy = object
		TraceAI ("ORBITWALK_ST -> CHASE_ST : ATTACKED_IN")
		return
	end

	local distance = GetDistanceFromOwner(MyID)
	if ( distance > UseOrbitWalk+2 or distance == -1) then		-- MYOWNER_OUTSIGNT_IN
		MyState = FOLLOW_ST
		TraceAI ("ORBITWALK_ST -> FOLLOW_ST")
		return
	end
	if (HPPercent(MyID)~=100 or SPPercent(MyID)~=100) then
		MyState = IDLE_ST
		TraceAI ("Low HP/SP, returning to idle state")
		return
	end
	local x, y = GetV (V_POSITION,MyID)
	local mymotion = GetV(V_MOTION,MyID)
	if (mymotion==MOTION_STAND) then
		if (x==MyDestX and y==MyDestY or OrbitWalkTries > 6) then
			if (OrbitWalkStep == 7) then
				OrbitWalkStep=0
			else
				OrbitWalkStep=OrbitWalkStep+1
			end
			OrbitWalkTries = 0
			local ownerx, ownery=GetV(V_POSITION,GetV(V_OWNER,MyID))
			local offx, offy = GetOrbitNext(UseOrbitWalk,OrbitWalkStep)
			MyDestX=ownerx+offx
			MyDestY=ownery+offy
			Move(MyID,MyDestX,MyDestY)
		else
			OrbitWalkTries = OrbitWalkTries +1
			Move(MyID,MyDestX,MyDestY)
		end
		return
	end	
end

-------------------
--Command State Process
-------------------

function	OnMOVE_CMD_ST ()

	TraceAI ("OnMOVE_CMD_ST")

	local x, y = GetV (V_POSITION,MyID)
	if (x == MyDestX and y == MyDestY) then				-- DESTINATION_ARRIVED_IN
		MyState = IDLE_ST
	end
end


function OnSTOP_CMD_ST ()


end




function OnATTACK_OBJECT_CMD_ST ()

	

end


function OnATTACK_AREA_CMD_ST ()

	TraceAI ("OnATTACK_AREA_CMD_ST")

	local	object = GetOwnerEnemy (MyID)
	if (object == 0) then							
		object = GetMyEnemy (MyID) 
	end

	if (object ~= 0) then							-- MYOWNER_ATTACKED_IN or ATTACKED_IN
		MyState = CHASE_ST
		MyEnemy = object
		return
	end

	local x , y = GetV (V_POSITION,MyID)
	if (x == MyDestX and y == MyDestY) then			-- DESTARRIVED_IN
			MyState = IDLE_ST
	end

end




function OnPATROL_CMD_ST ()

	TraceAI ("OnPATROL_CMD_ST")

	local	object = GetOwnerEnemy (MyID)
	if (object == 0) then							
		object = GetMyEnemy (MyID) 
	end

	if (object ~= 0) then							-- MYOWNER_ATTACKED_IN or ATTACKED_IN
		MyState = CHASE_ST
		MyEnemy = object
		TraceAI ("PATROL_CMD_ST -> CHASE_ST : ATTACKED_IN")
		return
	end

	local x , y = GetV (V_POSITION,MyID)
	if (x == MyDestX and y == MyDestY) then			-- DESTARRIVED_IN
		MyDestX = MyPatrolX
		MyDestY = MyPatrolY
		MyPatrolX = x
		MyPatrolY = y
		Move (MyID,MyDestX,MyDestY)
	end

end




function OnHOLD_CMD_ST ()

	TraceAI ("OnHOLD_CMD_ST")
	
	if (MyEnemy ~= 0) then
		local d = GetDistance(MyEnemy,MyID)
		if (d ~= -1 and d <= GetV(V_ATTACKRANGE,MyID)) then
				Attack (MyID,MyEnemy)
		else
			MyEnemy = 0;
		end
		return
	end


	local	object = GetOwnerEnemy (MyID)
	if (object == 0) then							
		object = GetMyEnemy (MyID)
		if (object == 0) then						
			return
		end
	end

	MyEnemy = object

end




function OnSKILL_OBJECT_CMD_ST ()
	
end




function OnSKILL_AREA_CMD_ST ()

	TraceAI ("OnSKILL_AREA_CMD_ST")

	local x , y = GetV (V_POSITION,MyID)
	if (GetDistance(x,y,MyDestX,MyDestY) <= GetV(V_SKILLATTACKRANGE,MyID,MySkill)) then	-- DESTARRIVED_IN
		SkillGround (MyID,MySkillLevel,MySkill,MyDestX,MyDestY)
		MyState = IDLE_ST
		MySkill = 0
	end

end







function OnFOLLOW_CMD_ST () --Who wrote the default version of this? God, they sucked. if (poslagged==true) then ScrewUp()
	TraceAI ("OnFOLLOW_CMD_ST")
	local d = GetDistance2 (GetV(V_OWNER,MyID),MyID)
	if ( d <= FollowStayBack) then
		return
	else
		BetterMoveToOwner (MyID)
		return
	end
	
end




-----------------
--GetOwnerEnemy
-----------------

function	GetOwnerEnemy (myid)
	local result = 0
	local owner  = GetV (V_OWNER,myid)
	local actors = GetActors ()
	local enemys = {}
	local index = 1
	local target
	if (SuperPassive==1) then
		return 0
	end
	for i,v in ipairs(actors) do
		if (v ~= owner and v ~= myid) then
			target = GetV (V_TARGET,v)
			if (IsFriend(target)==1) then
				if (IsMonster(v) == 1) then
					tact=GetTact(TACT_BASIC,v)
					if (tact > 1 and tact ~=9) then
						enemys[index] = v
						index = index+1
					end
				elseif (PVPmode~=0 and IsFriend(v)==0) then
					local motion = GetV(V_MOTION,v)
					if (motion == MOTION_ATTACK or motion == MOTION_ATTACK2) then
						enemys[index] = v
						index = index+1
					end
				end
			end
		end
	end
	local min_priority=2
	local priority
	local min_dis = 100
	local dis
	for i,v in ipairs(enemys) do
		dis = GetDistance2 (myid,v)
		priority=GetTact(TACT_BASIC,v)
		if (priority >= min_priority) then
			min_priority=priority
			if (dis < min_dis) then
				result = v
				min_dis = dis
			end
		end
	end
	
	return result
end




function	GetMyEnemy (myid)
	local result = 0
	local hpperc =HPPercent(myid)
	if (SuperPassive==1) then
		result=0
	elseif (hpperc > AggroHP and MyState~=REST_ST) then
		result = GetMyEnemyB (myid)
	else
		result = GetMyEnemyA (myid)
	end
	return result
end




-------------------------------------------
--  񼱰 GetMyEnemy
-------------------------------------------
function	GetMyEnemyA (myid)
	local result = 0
	local owner  = GetV (V_OWNER,myid)
	local actors = GetActors ()
	local enemys = {}
	local index = 1
	local target
	for i,v in ipairs(actors) do
		if (IsFriend(v)~=0 and v ~= myid) then
			target = GetV (V_TARGET,v)
			if (target == myid) then
				tact=GetTact(TACT_BASIC,v)
				if(tact > 1) then
					enemys[index] = v
					index = index+1
				end
			end
		end
	end
	local min_priority=2
	local priority
	local min_dis = 100
	local dis
	for i,v in ipairs(enemys) do
		dis = GetDistance2 (myid,v)
		priority=GetTact(TACT_BASIC,v)
		if (priority >= min_priority) then
			min_priority=priority
			if (dis < min_dis) then
				result = v
				min_dis = dis
			end
		end
	end

	return result
end






-------------------------------------------
--   GetMyEnemy
-------------------------------------------
function	GetMyEnemyB (myid)
	local result = 0
	local owner  = GetV (V_OWNER,myid)
	local actors = GetActors ()
	local enemys = {}
	local index = 1
	local type
	for i,v in ipairs(actors) do
		if (v ~= owner and v ~= myid and v ~= 0) then
			if (1 == IsMonster(v) or (PVPmode~=0 and IsEnemy(v)==1)) then
				tact=GetTact(TACT_BASIC,v)
				if(0 < tact and tact < 5) then
					if(IsNotKS(myid,v)==1) then
						TraceAI("Adding to target list: "..v)
						enemys[index] = v
						index = index+1
					end
				end
			end
		end
	end

	local min_priority=2
	local priority
	local min_dis = 100
	local dis
	for i,v in ipairs(enemys) do
		dis = GetDistance2 (myid,v)
		priority=GetTact(TACT_BASIC,v)
		if (priority >= min_priority) then
			min_priority=priority
			if (dis < min_dis) then
				result = v
				min_dis = dis
			end
		end
	end


	return result
end

---------------------
--DoIdleTasks
--Stuff that has to be done in a number of "idle" states, mostly autobuff stuff
--and command processing
---------------------

function DoIdleTasks()
	local cmd = List.popleft(ResCmdList)
	if (cmd ~= nil) then		
		ProcessCommand (cmd)	--  ɾ ó 
		return 
	end
	if (UseAutoQuicken == 1 and QuickenTimeout ~=-1) then
		if (GetTick() > QuickenTimeout) then
			local skill,level,sp,duration = GetQuickenSkill(GetV(V_MERTYPE,MyID))
			if (skill==0) then
				QuickenTimeout = -1
			elseif (sp <= GetV(V_SP,MyID)) then
				SkillObject(MyID,level,skill,MyID)
				QuickenTimeout = GetTick() + duration
				return
			end
		end
	end
	
	if (UseAutoGuard == 1 and GuardTimeout ~=-1) then
		if (GetTick() > GuardTimeout) then
			local skill,level,sp,duration = GetGuardSkill(GetV(V_MERTYPE,MyID))
			if (skill <= 0) then
				GuardTimeout = -1
			elseif (sp <= GetV(V_SP,MyID)) then
				SkillObject(MyID,level,skill,MyID)
				GuardTimeout = GetTick() + duration
				return
			end
		end
	end
	if (UseAutoMag == 1 and MagTimeout ~=-1) then
		if (GetTick() > MagTimeout) then
			if (GetV(V_MERTYPE,MyID)~=4) then
				MagTimeout = -1
			elseif (40 <= GetV(V_SP,MyID)) then
				SkillObject(MyID,1,MER_MAGNIFICAT,MyID)
				MagTimeout = GetTick() + 34000
				return
			end
		end
	end
	if (UseAutoSight == 1 and SightTimeout~=-1) then
		if (GetTick() > SightTimeout and IsHiddenOnScreen(MyID) == 1) then
			if (GetV(V_MERTYPE,MyID) ~= 2) then
				SightTimeout = -1
			elseif (10 <= GetV(V_SP,MyID)) then
				SkillObject(MyID,1,MER_SIGHT,MyID)
				SightTimeout = GetTick() + 10000
				return
			end
		end
	end
	
	if (UseProvokeOwner == 1 and ProvokeOwnerTimeout ~=-1) then
		if (GetTick() > ProvokeOwnerTimeout) then
			local skill,level,sp,duration = GetProvokeSkill(GetV(V_MERTYPE,MyID))
			if (skill <= 0) then
				ProvokeOwnerTimeout = -1
			elseif (sp <= GetV(V_SP,MyID)) then
				SkillObject(MyID,level,skill,GetV(V_OWNER,MyID))
				ProvokeOwnerTimeout = GetTick() + duration
				return
			end
		end
	end
	
	if (UseSacrificeOwner == 1 and SacrificeTimeout ~=-1) then
		if (GetTick() > SacrificeTimeout) then
			local skill,level,sp,duration = GetSacrificeSkill(GetV(V_MERTYPE,MyID))
			if (skill <= 0) then
				SacrificeTimeout = -1
			elseif (sp <= GetV(V_SP,MyID)) then
				SkillObject(MyID,level,skill,MyID)
				SacrificeTimeout = GetTick() + duration + 3000
				return
			end
		end
	end
	if (GetV(V_MOTION,GetV(V_OWNER,MyID))==MOTION_SIT and MyState~=REST_ST) then
		MyState=REST_ST
		return
	end
	return 1
end


---------------------
--DoRandomMove (yes, i know this is probably the Wrong Way to do this)
--Will be fixed if/when the random walk system is updated.
---------------------


function	DoRandomMove()
	TraceAI ("Random Move Called")
	local x, y = GetV(V_POSITION,MyID)
	local xsign=2*math.random(0,1)-1
	local ysign=2*math.random(0,1)-1
	MyDestX=x+math.random(6,9)*xsign
	MyDestY=y+math.random(6,9)*ysign
	Move(MyID,MyDestX,MyDestY)
	RandWalkTries=0
	MyState=RANDWALK_ST
	return
end

----------------------
--DoAutoPushback
----------------------
function DoAutoPushback(myid)
	local actors = GetActors()
	local x,y=GetV(V_POSITION,myid)
	for i,v in ipairs(actors) do
		if (IsMonster(v)==1 or (PVPmode~=0 and IsEnemy(v)~=0)) then
			local target=GetV(V_TARGET,v)
			if ((UseAutoPushback == 2 and IsFriend(target)==1) or target==myid) then
				if (GetDistance2(target,v) <= AutoPushbackThreshold) then
					TraceAI("Enemies close to me, using pushback")
					local skill,level,sp,targetmode=GetPushbackSkill(GetV(V_MERTYPE,myid))
					if (skill==0) then
						UseAutoPushback=0
					elseif (GetV(V_SP,myid) >= sp) then
						if (targetmode==1) then
							SkillObject(myid,level,skill,v)
						elseif (targetmode==2) then
							local ex,ey=GetV(V_POSITION,v)
							local x,y=Closer(myid,ex,ey)
							SkillGround(myid,level,skill,x,y)
						end
						return
					end
					break
				end
			end
		end
	end
	return 1
end
----------------------
--DoKiteAdjust
----------------------

function DoKiteAdjust(myid,enemy)
	local step
	local target=GetV(V_TARGET,enemy)
	if (IsFriend(target)==1 or target==MyID) then
		step=KiteStep
	else
		step=KiteParanoidStep
	end
	local x,y=GetV(V_POSITION,myid)
	local ox,oy=GetV(V_POSITION,GetV(V_OWNER,myid))
	local ex,ey=GetV(V_POSITION,enemy)
	local xoptions ={[2]=1,[0]=1,[1]=1}
	local yoptions ={[2]=1,[0]=1,[1]=1}
	local xdirection,ydirection=0,0
	if (x > ex) then
		xoptions[2]=0
	elseif (x < ex) then
		xoptions[1]=0
	else
		yoptions[0]=0
	end
	if (y > ey) then
		yoptions[2]=0
	elseif (y < ey) then
		yoptions[1]=0
	else
		xoptions[0]=0
	end
	if (ox > x) then
		if (xoptions[1]==1) then
			xdirection=1
		elseif (xoptions[0]==1) then
			xdirection=0
		elseif (xoptions[2]==1 and (ox-x+step) <= KiteBounds) then
			xdirection=-1
		elseif	(ey < y) then
			xdirection=0
		else
			xdirection=1
		end
	else
		if (xoptions[2]==1) then
			xdirection=-1
		elseif (xoptions[0]==1) then
			xdirection=0
		elseif (xoptions[1]==1 and (x-ox+step) <= KiteBounds) then
			xdirection=1
		elseif	(ey > y) then
			xdirection=0
		else
			xdirection=-1
		end
	end
	if (oy > y) then
		if (yoptions[1]==1) then
			ydirection=1
		elseif (yoptions[0]==1) then
			ydirection=0
		elseif (yoptions[2]==1 and oy-y+step <= step) then
			ydirection=-1
		elseif	(ex > x and xdirection~=0) then
			ydirection=0
		else
			ydirection=1
		end
	else 
		if (yoptions[2]==1) then
			ydirection=-1
		elseif (yoptions[0]==1) then
			ydirection=0
		elseif (yoptions[1]==1 and y-oy+step <= KiteBounds) then
			ydirection=1
		elseif	(ex < x and xdirection~=0) then
			ydirection=0
		else
			ydirection=-1
		end
	end
	TraceAI("Kiteing in "..xdirection..","..ydirection.." direction")
	MyDestX=x+step*xdirection
	MyDestY=y+step*ydirection
	Move(myid,MyDestX,MyDestY)
end
----------------------
--Main AI Function
----------------------

function AI(myid)

	MyID = myid
	local msg	= GetMsg (myid)			-- command
	local rmsg	= GetResMsg (myid)		-- reserved command

	
	if msg[1] == NONE_CMD then
		if rmsg[1] ~= NONE_CMD then
			if List.size(ResCmdList) < 10 then
				List.pushright (ResCmdList,rmsg) --   
			end
		end
	else
		List.clear (ResCmdList)	-- ο  ԷµǸ  ɵ Ѵ.  
		ProcessCommand (msg)	-- ɾ ó 
	end

		
	-- Prevent from being left behind
	-- Used only in critical (merc out of MoveBounds) situations
	-- Otherwise, IDLE_ST handles it
	
	local dist2owner=GetDistance2(MyID,GetV(V_OWNER,MyID))
	if (MyState ~=FOLLOW_ST and dist2owner > MoveBounds) then
		MyState=FOLLOW_ST
	end
	--Cancel all action during the spawn invulnerability
	if (GetTick() < (MyStart + SpawnDelay)) then
		return
	end
	
	-- Check to see if mercenary should activate kiting routine
	if (KiteMonsters==1 and (GetV(V_MERTYPE,MyID) < 11 or ForceKite~=0)) then
		local x,y=GetV(V_POSITION,MyID)
		if ((x==KiteDestX and y==KiteDestY) or (KiteDestX==0 and KiteDestY==0)) then
			local actors = GetActors()
			kitecalled=0
			for i,v in ipairs(actors) do
				if (IsMonster(v)==1 or (PVPmode~=0 and IsFriend(v)==0)) then
					local target=GetV(V_TARGET,v)
					if (IsFriend(target)==1 or target==MyID or KiteParanoid==1) then
						local threshold
						if (IsFriend(target)==1 or target==MyID) then
							threshold=KiteThreshold
						else
							threshold=KiteParanoidThreshold
						end
						if (GetDistance2(MyID,v) <= threshold) then
							TraceAI("Enemies close to me, start kite routine. ")
							DoKiteAdjust(MyID,v)
							kitecalled=1
							break
						end
					end
				end
			end
			if (kitecalled == 0) then
				KiteDestX,KiteDestY=0,0
			end
		else
			Move(myid,KiteDestX,KiteDestY)
		end
	end
	--Do state processes
 	if (MyState == IDLE_ST) then
		OnIDLE_ST ()
	elseif (MyState == CHASE_ST) then					
		OnCHASE_ST ()
	elseif (MyState == ATTACK_ST) then
		OnATTACK_ST ()
	elseif (MyState == FOLLOW_ST) then
		OnFOLLOW_ST ()
	elseif (MyState == MOVE_CMD_ST) then
		OnMOVE_CMD_ST ()
	elseif (MyState == STOP_CMD_ST) then
		OnSTOP_CMD_ST ()
	elseif (MyState == ATTACK_OBJECT_CMD_ST) then
		OnATTACK_OBJECT_CMD_ST ()
	elseif (MyState == ATTACK_AREA_CMD_ST) then
		OnATTACK_AREA_CMD_ST ()
	elseif (MyState == PATROL_CMD_ST) then
		OnPATROL_CMD_ST ()
	elseif (MyState == HOLD_CMD_ST) then
		OnHOLD_CMD_ST ()
	elseif (MyState == SKILL_OBJECT_CMD_ST) then
		OnSKILL_OBJECT_CMD_ST ()
	elseif (MyState == SKILL_AREA_CMD_ST) then
		OnSKILL_AREA_CMD_ST ()
	elseif (MyState == FOLLOW_CMD_ST) then
		OnFOLLOW_CMD_ST ()
	elseif (MyState == RANDWALK_ST) then
		OnRANDWALK_ST ()
	elseif (MyState == ORBITWALK_ST) then
		OnORBITWALK_ST()
	elseif (MyState == REST_ST) then
		TraceAI("Calling OnREST_ST()")
		OnREST_ST()
	end

end
